#!/usr/bin/php
<?php
/*
   . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
  '    DIFERIOR (http://diferior.com)
  '  ---------------------------------------
  '
  '	This file is part of Diferior (http://diferior.com).
  '
  ' Diferior is free software: you can redistribute it and/or modify
  ' it under the terms of the GNU General Public License as published by
  ' the Free Software Foundation, either version 3 of the License, or
  ' (at your option) any later version.
  '
  ' Diferior is distributed in the hope that it will be useful,
  ' but WITHOUT ANY WARRANTY; without even the implied warranty of
  ' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ' GNU General Public License for more details.
  '
  ' You should have received a copy of the GNU General Public License
  ' along with Diferior.  If not, see <http://www.gnu.org/licenses/>.
  '  
  '  ---------------------------------------
  '    Diferior is copyright 2007, 2008 Povilas Musteikis
   . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
*/

# Only allow running via CLI (check based on one from go-pear)
$sapi_name = php_sapi_name();
if ( $sapi_name != 'cli' && !( substr ( $sapi_name, 0, 3 ) == 'cgi' && !isset ( $_SERVER [ 'GATEWAY_INTERFACE' ] ) ) )
die ( 'This file can only be run via CLI' );

define ( 'VIA_INDEX', true );


##############################################
#### Bonus ;) shell script that lists users that added most downloads during past 7 days. Great for competitions.
##############################################

//error_reporting ( E_ALL );

date_default_timezone_set ( 'GMT' );
//require_once ( '../conf.localhost.php' );

require_once ( dirname(__FILE__).'/../conf.php' );
require_once ( dirname(__FILE__).'/../error.php' );

# Set error and exception handlers
set_error_handler ( array ( 'error', 'php_error_handler' ) );
set_exception_handler ( array ( 'error', 'php_exception_handler' ) );
	
try 
{

	# Load core
	require_once ( dirname(__FILE__).'/../core.php' );

	$db = & core::load_file ( 'db' );

	$time = strtotime ( '-7 days' );
	
	$res = $db -> get_all ( "SELECT DISTINCT user FROM dl_downloads WHERE posted>=". $time );

	$top = array ();
	
	foreach ( $res as $v )
	{
		$user = & $v [ 'user' ];
		$count = $db -> get_one ( "SELECT COUNT(*) FROM dl_downloads WHERE user='". $user ."' AND posted>=". $time );
		$top [ $user ] = $count;
	}
	
	arsort ( $top, SORT_NUMERIC );
	
	foreach ( $top as $k => $v )
	{
		echo $k ." - ". $v . "\n";
	}
	
}
catch ( error $e )
{
	
	error::display_error ( $e );
	
}

?>